indexing
    description    : "Allegro cone Eiffel: ACE"
    status         : "Initial development"
    author         : "Peter Monks (pmonks@iname.com)"
    allegro_author : "Shawn Hargreaves (shawn@talula.demon.co.uk)"
    names          : ace
    date_started   : "1st December, 1996"
    version        : "0.1 beta"
    platforms      : "MS-DOS"
    dependencies   : "Allegro v2.2, DJGPP v2.01"


deferred class ACE


inherit

    ACE_INFORMATION_SINGLETON  -- implementation inheritance
    end                        -- end inherit ACE_INFORMATION_SINGLETON


------------------------------------------------------ Features
feature { ANY }

    init : ACE_INITIALISE is
    -- Create a single ACE_INITIALISE object
    once
        !!Result.make
    end  -- feature init


    screen : SCREEN is
    -- Create a single SCREEN object
    once
        !!Result
    end  -- feature screen


    timer : TIMER is
    -- A useful alias for timer1
    once
        Result := timer1
    end  -- feature timer


    timer1 : TIMER is
    -- Create the timer1 object
    once
        !!Result.make(1)
    end  -- feature timer1


    timer2 : TIMER is
    -- Create the timer2 object
    once
        !!Result.make(2)
    end  -- feature timer2


    timer3 : TIMER is
    -- Create the timer3 object
    once
        !!Result.make(3)
    end  -- feature timer3


    retrace_simulator : RETRACE_SIMULATOR is
    -- Create a single RETRACE_SIMULATOR object
    once
        !!Result.make
    end  -- feature retrace_simulator


    mouse : MOUSE is
    -- Create a single MOUSE object
    once
        !!Result.make
    end  -- feature mouse


    joystick : JOYSTICK is
    -- Create a single JOYSTICK object
    once
        !!Result.make
    end  -- feature joystick


    keyboard : KEYBOARD is
    -- Create a single KEYBOARD object
    once
        !!Result.make
    end  -- feature keyboard


    soundcard : SOUNDCARD is
    -- Create a single SOUNDCARD object
    once
        !!Result.make
    end  -- feature soundcard


    -- Declare a single ACE_FILE_TOOLS object
    ace_file_tools : ACE_FILE_TOOLS


    default_font : FONT is
    -- Create a FONT object containing the default font
    once
        !!Result.make
    end  -- feature default_font


end  -- class ACE
 
