/******************
* Name: SCREEN.C
* Type: Linkable module (either library or object file)
* Does: Provides screen routines for the ACE package.
* Author: Peter Monks (pmonks@iname.com)
* Refer: Class SCREEN in SCREEN.E
*******************/

#include <stdlib.h>
#include <dos.h>
#include <conio.h>

#include "allegro.h"
#include "common.h"
#include "screen.h"


/* Returns the constant value (GFX_xx) of the current video driver. */
inline int driver(void)
{
    if(gfx_driver == &gfx_vga)
        return(GFX_VGA);
    else if(gfx_driver == &gfx_modex)
        return(GFX_MODEX);
    else if(gfx_driver == &gfx_vesa_1)
        return(GFX_VESA1);
    else if(gfx_driver == &gfx_vesa_2b)
        return(GFX_VESA2B);
    else if(gfx_driver == &gfx_vesa_2l)
        return(GFX_VESA2L);
    else if(gfx_driver == &gfx_vbeaf)
        return(GFX_VBEAF);
    else if(gfx_driver == &gfx_xtended)
        return(GFX_XTENDED);
    else if(gfx_driver == &gfx_ati)
        return(GFX_ATI);
    else if(gfx_driver == &gfx_mach64)
        return(GFX_MACH64);
    else if(gfx_driver == &gfx_cirrus64)
        return(GFX_CIRRUS64);
    else if(gfx_driver == &gfx_cirrus54)
        return(GFX_CIRRUS54);
    else if(gfx_driver == &gfx_paradise)
        return(GFX_PARADISE);
    else if(gfx_driver == &gfx_s3)
        return(GFX_S3);
    else if(gfx_driver == &gfx_trident)
        return(GFX_TRIDENT);
    else if(gfx_driver == &gfx_et3000)
        return(GFX_ET3000);
    else if(gfx_driver == &gfx_et4000)
        return(GFX_ET4000);
    else if(gfx_driver == &gfx_video7)
        return(GFX_VIDEO7);

    return(GFX_TEXT);
}
